# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Role-Tiny
Version:	2.002004
Release:	8.%{__distinit}%{__distvers}
Summary:	A nouvelle cuisine portion size slice of Moose
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Role-Tiny
Source0:	https://cpan.metacpan.org/authors/id/H/HA/HAARG/Role-Tiny-%{version}.tar.gz
BuildArch:	noarch
# Module Build ------------------------------------------------
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime ----------------------------------------------
BuildRequires:	perl(Carp)
BuildRequires:	perl(Class::Method::Modifiers) >= 1.05
BuildRequires:	perl(Exporter)
BuildRequires:	perl(mro)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite --------------------------------------------------
BuildRequires:	perl(base)
BuildRequires:	perl(constant)
BuildRequires:	perl(lib)
BuildRequires:	perl(overload)
BuildRequires:	perl(Test::More) >= 0.88
# Dependencies ------------------------------------------------
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Carp)
Requires:	perl(Class::Method::Modifiers) >= 1.05
Requires:	perl(mro)

%description
Role::Tiny is a minimalist role composition tool.

%prep
%setup -q -n Role-Tiny-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/Role/
%{_mandir}/man3/Role::Tiny.3*
%{_mandir}/man3/Role::Tiny::With.3*

%changelog
* Thu May 11 2023 Paul Howarth <paul@city-fan.org> - 2.002004-8
- Use SPDX-format license tag
- Drop conflict with perl-Moo versions more than 10 years old

* Sun Jan 24 2021 Paul Howarth <paul@city-fan.org> - 2.002004-1
- Update to 2.002004
  - Restore requiring base class when using create_class_with_roles, which was
    accidentally lost in 2.002_000 (CPAN RT#134075)

* Tue Jan 12 2021 Paul Howarth <paul@city-fan.org> - 2.002003-1
- Update to 2.002003
  - Refactored create_class_with_roles to not use "composable packages"; this
    was an optimization for when a role is used in many different uses of
    create_class_with_roles, but required an entirely separate implementation,
    which did not have fully compatible behaviour and would also result in
    methods using modifiers being slower
  - Add documentation for which methods will be composed from a role
    (CPAN RT#133363)
  - Fix backwards compatibility with older versions of Moo when interacting
    with Moose
  - Treat modifiers as required methods during create_class_with_roles
  - Fixed methods being no longer composed after they participated in an
    allowed conflict
  - Dropped use of MRO::Compat
  - Test cleanups for checking requires during create_class_with_roles
  - Additional tests to confirm internal role application steps can be fully
    qualified
  - Fix Pod links to Class::Method::Modifiers
  - Tweaks to author tests
  - Additional tests for working with older Moo versions
  - Additional tests for module loading
  - Allow method modifiers to be specified with an array reference of method
    names, rather than a list; this now matches how the corresponding
    Class::Method::Modifiers subs can be called
  - Fix tests when Class::Method::Modifiers is not installed
  - Refactored some internals for subclasses to use
  - methods_provided_by will ensure the module is loaded before checking for
    methods
  - Set dynamic_config to 0 and x_static_install to 1
  - Fixed filenames in dependents author test not to use colons
  - Removed MRO::Compat from prereqs as it is no longer used
  - Marked Class::Method::Modifiers as a hard developer dependency rather than
    a recommended developer dependency
  - Rewrote test for namespace cleaning not to require namespace::clean, and
    moved it from an author test to a normal test
  - Removed namespace::autoclean from developer prereqs
- Use %%license unconditionally

* Fri Oct 25 2019 Paul Howarth <paul@city-fan.org> - 2.001004-1
- Update to 2.001004
  - Fix methods being excluded from composition if they previously existed in
    the composing role (CPAN RT#130811)
  - Fix role application overwriting subs that are not considered methods
  - Fix helper subs created by a Role::Tiny extension (like Moo::Role)
    sometimes being treated as methods

* Wed Oct  9 2019 Paul Howarth <paul@city-fan.org> - 2.001003-1
- Update to 2.001003
  - Fix methods from roles composed via create_class_with_roles being treated
    differently than roles composed directly (CPAN RT#128470)
  - Fix constants being included in the methods provided by a role if they were
    created before importing Role::Tiny but used after importing
  - Fix prototype handling test on cperl

* Thu Oct  3 2019 Paul Howarth <paul@city-fan.org> - 2.001001-1
- Update to 2.001001
  - Fix composing roles into packages that have stub subs in them
  - Treat constants consistently with all other subs, no matter where they are
    defined
  - Refactored method tracking to allow easier extending (such as by Moo)
  - Added make_role method to make a package into a role, but without exporting
    any subs into it
  - Refactored sub exporting to allow extensions to do different things with
    the subs
  - Added tests for make_role

* Mon Aug 12 2019 Paul Howarth <paul@city-fan.org> - 2.000008-1
- Update to 2.000008
  - Reverting all changes from 2.000007 due to failures on some perl versions
    and a number of downstream users; the changes will be re-introduced in a
    fixed form in a future version
- This release by HAARG → update source URL accordingly

* Thu Aug  1 2019 Paul Howarth <paul@city-fan.org> - 2.000007-1
- Update to 2.000007
  - Fix composing roles into packages that have stub subs in them
  - Exclude all constant subs from method list
- This release by ETHER → update source URL accordingly
- Package LICENSE file

* Thu Jun  6 2019 Paul Howarth <paul@city-fan.org> - 2.000006-8
- Perl 5.30 rebuild

* Wed Nov  8 2017 Paul Howarth <paul@city-fan.org> - 2.000006-1
- Update to 2.000006
  - Account for code references stored directly in stash (for perl 5.28)
  - Work around hint leakage when loading modules in perl 5.8 and 5.10.1
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - MRO support is always via perl(mro) now
  - Drop workaround for building with Test::More < 0.88

* Wed Nov  2 2016 Paul Howarth <paul@city-fan.org> - 2.000005-1
- Update to 2.000005
  - Revert change to MRO::Compat usage
- Update patch for building with old distributions

* Tue Nov  1 2016 Paul Howarth <paul@city-fan.org> - 2.000004-1
- Update to 2.000004
  - Fix consuming stubs from roles (CPAN RT#116674)
  - Fix error message when applying conflicting roles to an object
  - Drop prerequisite on MRO::Compat on perl 5.8
- Add patch to fix broken perl 5.8 support (CPAN RT#118583)
- Update patch for building with old distributions

* Fri Sep 23 2016 Paul Howarth <paul@city-fan.org> - 2.000003-3
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available

* Fri Apr 22 2016 Paul Howarth <paul@city-fan.org> - 2.000003-1
- Update to 2.000003
  - Don't install subs if importing into a package that is already a role; this
    can happen if the module previously imported Moo::Role

* Wed Apr 20 2016 Paul Howarth <paul@city-fan.org> - 2.000002-1
- Update to 2.000002
  - Restore compatibility with Moo versions pre 1.004_003
  - Delay loading Class::Method::Modifiers until applying modifiers to a package
  - Use croak rather than die for reporting errors
  - Apply method modifiers only once, even if they are applied via multiple
    composition paths (CPAN RT#106668)
- Simplify find command using -delete
- Update patch for building with old distributions

* Thu Jun 25 2015 Paul Howarth <paul@city-fan.org> - 2.000001-4
- Perl 5.22 rebuild

* Sun Apr 26 2015 Paul Howarth <paul@city-fan.org> - 2.000001-1
- Update to 2.000001
  - Fix generating invalid package names with single colons when abbreviating
    long package names (CPAN RT#103310)
  - Don't run module interaction tests for user installs
- Update patch for building with old distributions

* Thu Feb 26 2015 Paul Howarth <paul@city-fan.org> - 2.000000-1
- Update to 2.000000
  - Incompatible change: Role::Tiny no longer applies fatal warnings to roles
    created with it; strict and non-fatal warnings will continue to be applied
- Update patch for building with old distributions

* Thu Oct 23 2014 Paul Howarth <paul@city-fan.org> - 1.003004-1
- Update to 1.003004
  - Allow does_role to be overridden by Moo::Role
- Classify buildreqs by usage
- Update patch for building with old distributions

* Thu Sep 11 2014 Paul Howarth <paul@city-fan.org> - 1.003003-4
- Perl 5.20 rebuild

* Wed Aug 27 2014 Paul Howarth <paul@city-fan.org> - 1.003003-3
- Don't BR: perl(namespace::autoclean) when bootstrapping
- Drop %%defattr, redundant since rpm 4.4

* Sun Mar 16 2014 Paul Howarth <paul@city-fan.org> - 1.003003-2
- BR:/R: perl(Class::Method::Modifiers) unconditionally

* Sat Mar 15 2014 Paul Howarth <paul@city-fan.org> - 1.003003-1
- Update to 1.003003
  - Overloads specified as method names rather than subrefs are now applied
    properly
  - Allow superclass to provide conflicting methods (CPAN RT#91054)
  - Use ->is_role internally to check if a package is a role
  - Document that Role::Tiny applies strict and fatal warnings
- Require Class::Method::Modifiers at runtime where possible
- Update patch for building with old distributions

* Mon Mar  3 2014 Paul Howarth <paul@city-fan.org> - 1.003002-3
- Add support for building with old distributions

* Fri Dec 20 2013 Paul Howarth <paul@city-fan.org> - 1.003002-2
- Import from Fedora

* Fri Oct 18 2013 Miro Hrončok <mhroncok@redhat.com> - 1.003002-1
- 1.003002 bump

* Fri Aug 16 2013 Jitka Plesnikova <jplesnik@redhat.com> - 1.003001-1
- 1.003001 bump
- Specify all dependencies

* Sat Aug 03 2013 Petr Pisar <ppisar@redhat.com> - 1.002005-2
- Perl 5.18 rebuild

* Fri Feb 15 2013 Iain Arnell <iarnell@gmail.com> - 1.002005-1
- Update to latest upstream version

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.002004-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Nov 02 2012 Iain Arnell <iarnell@gmail.com> - 1.002004-1
- Update to latest upstream version

* Sun Oct 28 2012 Iain Arnell <iarnell@gmail.com> - 1.002002-1
- Update to latest upstream version

* Sat Oct 27 2012 Iain Arnell <iarnell@gmail.com> - 1.002001-1
- Update to latest upstream version

* Sat Oct 20 2012 Iain Arnell <iarnell@gmail.com> - 1.002000-1
- Update to latest upstream version

* Sun Jul 29 2012 Iain Arnell <iarnell@gmail.com> - 1.001005-1
- Update to latest upstream version

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.001004-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Jul 17 2012 Iain Arnell <iarnell@gmail.com> - 1.001004-1
- Update to latest upstream version

* Fri Jun 22 2012 Petr Pisar <ppisar@redhat.com> - 1.001002-2
- Perl 5.16 rebuild

* Tue May 08 2012 Iain Arnell <iarnell@gmail.com> - 1.001002-1
- Update to latest upstream version

* Fri Apr 27 2012 Iain Arnell <iarnell@gmail.com> - 1.001001-1
- Update to latest upstream version
- Don't explicity require Class::Method::Modifiers

* Wed Apr 04 2012 Iain Arnell <iarnell@gmail.com> - 1.000001-1
- Update to latest upstream version

* Mon Apr 02 2012 Iain Arnell <iarnell@gmail.com> - 1.000000-3
- Explicitly conflict with perl-Moo < 0.009014; this module used to be
  distributed as part of Moo

* Mon Apr 02 2012 Iain Arnell <iarnell@gmail.com> - 1.000000-2
- Fix spelling of cuisine in summary

* Sun Apr 01 2012 Iain Arnell <iarnell@gmail.com> - 1.000000-1
- Specfile autogenerated by cpanspec 1.79
